/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Leonid Tsybert
 * Student ID: 9822045
 * Section:    BD
 *	
 */

#include "gp142.h"
#include <math.h>
#include <time.h>

#define TRUE    		1
#define FALSE   		0


#define PI				3.1415926535

#define NUMBUTTONS 	7
 /* Configure the appearance of the buttons on the menu bar 
 * by setting the number of pixels of button height and width
 */
#define BUT_HEIGHT		35
#define BUT_WIDTH 		95
#define BUT_HORIZ		10				/* Distance from the left border to the buttons */
#define BUT_VERTSEP		3				/* Small vertical separation between buttons */
#define BUT_VERTSEP2	20				/* Large vertical separation between buttons */

#define B_NONE			(-1)
#define B_NEWSHAPE		0
#define B_NEWMESSAGE	1
#define B_NEXT			2
#define B_BACKCOLOR		3
#define B_OBJECTCOLOR	4
#define B_SELECT		5
#define B_DELETE		6

 
/* This depends on buttons' orientation, total amount of empty space between
the first and the last button */
#define BUT_TOTALSEP	(3 * BUT_VERTSEP2 + 3 * BUT_VERTSEP)

#define FONT_SIZE		20

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUT_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL	0
#define NOFILL	1

/* OBJECTS */
#define OBJECT_NONE			0		/* No object is stored in this element of array */
#define OBJECT_SHAPE		1		/* A shape is stored in this element of array */
#define OBJECT_MESSAGE		2		/* A message is stored in this element of array */
#define OBJECT_END			(-1)		/* This is reserved for the last element of array */

/*if you add new types, you may need to change this*/
#define MAX_SHAPES		5

#define MAX_MESSAGES	8
#define MESSAGELENGTH	30
/* These are the kinds of shapes we support.  You'll need to add more. */
#define SHAPE_HEART		0
#define SHAPE_STAR		1
#define SHAPE_SMILEY	2
#define SHAPE_SMILEY2	3
#define SHAPE_SMILEY3	4

/*Possible places for mouse clicks*/
#define CLICK_TOOLBAR		1	/* You clicked on the area where buttons lie)*/
#define CLICK_CARD			2   /* You clicked in the card area */
#define CLICK_OUTSIDE		3	/* You clicked outside the card area, not on a button*/	


#define MAXOBJECTS			100	 

/*The status can be several values.  It can either be the index of a selected shape in the objArrray,
indicating that an object of that index is selected, or it can have the value ADDSHAPE in which case
we add a new shape when the card is clicked, or it can be ADDMESSAGE in which case we add a new message
when the card is clicked, or it can be SELECT, meaning that we try to select a new object when the card
is clicked. */
#define ADDSHAPE			(MAXOBJECTS + 1)	/* value indicating a new shape is to be added */
#define ADDMESSAGE			(MAXOBJECTS + 2)	/* value indicating a new message is to be added */
#define SELECT				(MAXOBJECTS + 3)	/* value indicating that a shape will be selected */
#define MAXREACHED			(MAXOBJECTS + 4)	/* value indicating that a maximum amount of objects */
												/* has been placed on the card */

typedef	struct {
	int x;						/* x coordinate */
	int y;						/* y coordinate */
	int type;					/* shape, message, or nothing */
	int index;					/* index of a shape or of a message */
	int color;					/* current color of a shape or a message*/
	int size;					/* size of font */
	int top;					/* distance to top from center */
	int bottom;					/* distance to bottom from center*/
	int left;					/* distance to left from center */
	int right;					/* distance to right from center */
  } OBJECT;


/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
/*Draws an arc, of color iColor, radius iRadius, from angle1 to angle 2 (in radians),
and of thickness iThickness. */
void DrawArc(int iColor, int iRadius, double dAngle1, double dAngle2, int x, int y,
			 int iThickness);
void DrawBlankScreen (void);
void DrawCard (int background_color, int iSelected, OBJECT objArray[]);
void DrawShape(OBJECT *pobj, int iBackground, int flagSelected);
void DrawMessage(OBJECT *pobj, int iBackground, int flagSelected);
void DrawHeart (OBJECT *pobj, int iBackground, int flagSelect);
void DrawStar (OBJECT *pobj, int iBackground, int flagSelect);
void DrawSmiley(OBJECT *pobj, int iBackground, int flagSelect);
void DrawSmiley2(OBJECT *pobj, int iBackground, int flagSelect);
void DrawSmiley3(OBJECT *pobj, int iBackground, int flagSelect);
/* Draws the selection markers around a selected shape */
void DrawSelectMarkers(OBJECT *pobj, int iBackground);
/* Draw buttons */
void DrawButtons(int iSelected, int *ipButtonClick);
void DrawOneButton(GP142_point pt1, GP142_point pt2, 
				   int text_xoffset, int text_yoffset, 
				   char *pszLabel, int fPressed, int fDisabled);
/* Draw a surface for the button */
void DrawButtonSurface(GP142_point pt1, GP142_point pt2, int fPressed, int fDisabled);
void DrawEmptyToolbar(void);
void DrawTitle(void);

void AssignShape(OBJECT *pobj);
char *FindMessage(int iNum);

/* Mouse click handling functions */
void HandleMouseClick(GP142_point ptMouse, int *background_color, 
					  int *ipSelected, int *ipButtonClick, OBJECT objArray[]);
int ClassifyMouseClick(GP142_point ptMouse);
void HandleButton(GP142_point ptMouse, int *background_color, int *ipSelected,
				  int *ipButtonClick, OBJECT objArray[]);

/* Add a shape to the card. */
int NewShape(GP142_point ptMouse, int *ipSelected, OBJECT objArray[]);
int NewMessage(GP142_point ptMouse, int *ipSelected, OBJECT objArray[]);
void MoveShape(GP142_point ptMouse, OBJECT *pobjObject);

/* Select an object if mouse was clicked by it */
void Select(GP142_point ptMouse, int *ipSelected, OBJECT objArray[]);
void Delete(OBJECT objArray[], int *ipSelected);
/* Initialize object array */
void InitArray(OBJECT objArray[]);

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int quit = FALSE;              /* becomes TRUE to exit program */
	
	/*variables and their default values*/
	int background_color = TURQUOISE;
	int iSelected = ADDSHAPE;
	
	int	event;
	int iButtonClick = B_NONE;	/* No button has been clicked */
	GP142_event_t	eventInfo;
	GP142_point ptMouse;
	OBJECT objArray[MAXOBJECTS];
	
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */

	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	InitArray(objArray);

	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		
		/* Make the background gray */
		GP142_rectangleXY(MED_GRAY, -GP142_XMAX, -GP142_YMAX, GP142_XMAX, GP142_YMAX, 0);
		
		/* Draw a title bar */
		DrawTitle();
		/* Draw a background in a different color over where the buttons are */
		DrawEmptyToolbar();
				
		DrawCard (background_color, iSelected, objArray);
		
		DrawButtons(iSelected, &iButtonClick);	  /* Show the buttons...*/ 
		
		/*Wait for something to happen */

		event = GP142_await_eventP(&eventInfo);

		ptMouse.x = eventInfo.x;
		ptMouse.y = eventInfo.y;
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(ptMouse, &background_color, &iSelected, &iButtonClick, 
						objArray);			
			break;
			
		case GP142_PERIODIC:
			break;

		default:
			
			break;
			
		}  /*end switch */
		
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/

/* Draw an arc of a circle of radius iRadius, from dAngle1 to dAngle2, which
must be in radians */
void DrawArc(int iColor, int iRadius, double dAngle1, double dAngle2, int x, int y,
			 int iThickness)
{
	int xPixel, yPixel, iStartRadius, iEndRadius, r;
	double dThetaRad, dInc;

	/*If the arc is more than one pixels thick, its radius the distance from
	the center of the circle to the midpoint of the thickness.  This function
	draws iThickness number of arcs 1 pixel wide to get the arc be iThickness
	thick.  Odd and even numbers for iThickness must be handled differently. */
	

	iEndRadius = iRadius + iThickness / 2;

	if(iThickness % 2 != 0)		/* if thickness is odd */
	{
		iStartRadius = iRadius - iThickness / 2;
	}
	else						/* if thickness is even */
	{
		/* This prevents arcs with an even number for thickness from being
		identical to arcs with an odd thickness */
		iStartRadius = iRadius - iThickness / 2 + 1;
	}
	for(r = iStartRadius;r <= iEndRadius; r++)
	{

		/* We need to find the value by which to increment the angle as each pixel
		is drawn.  This value will depend on the radius, the larger the radius, 
		the farther	apart the pixels are for each angle increment.  The increment 
		should be small enough so that there are no breaks between the pixels, and 
		large enough so that there wouldn't be very many pixels that are drawn in the 
		same place.  Theoretically, there are 1 radius of pixels in an arc of 1 radian,
		so the increment 1 / radius looks very nice when thickness = 1.	However, when 
		thickness is more than 1, there are "holes" in the arc.  The formula that I 
		chose is inc = 5 * (1 / Radius) / 10 */

		dInc = 5 * (1.0 / r) / 10;
		for(dThetaRad = dAngle1; dThetaRad <= dAngle2; dThetaRad += dInc)
		{
			xPixel = x + (int)(r * cos(dThetaRad)) ;
			yPixel = y + (int)(r * sin(dThetaRad)) ;
			
			
			GP142_pixelXY(iColor, xPixel, yPixel);
		}
	}
}
/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) {

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */

void DrawTitle(void)
{
	/* Draw the background for the title */
	GP142_rectangleXY(LT_GRAY, -GP142_XMAX, GP142_YMAX, GP142_XMAX, 
					GP142_YMAX - 46, FILL);

	/* Diplay the message in "3d" letters */
	GP142_printfXY(WHITE,
				-GP142_XMAX + BUT_WIDTH + 3 * BUT_HORIZ + 60-1, 
				GP142_YMAX - 40 + 1, 
				27,
				"Valentine's Day Card Designer!");
	
	
	GP142_printfXY(BLACK,
				-GP142_XMAX + BUT_WIDTH + 3 * BUT_HORIZ + 60 + 1, 
				GP142_YMAX - 40 - 1, 
				27,
				"Valentine's Day Card Designer!");

	GP142_printfXY(MED_GRAY,
				-GP142_XMAX + BUT_WIDTH + 3 * BUT_HORIZ + 60, 
				GP142_YMAX - 40, 
				27,
				"Valentine's Day Card Designer!");

}



/* Draws the gray area on which buttons are drawn */
void DrawEmptyToolbar(void)
{
	GP142_point ptUpperLeft, ptLowerRight;

	ptUpperLeft.x = -GP142_XMAX + 3;
	ptUpperLeft.y = GP142_YMAX - 2;

	ptLowerRight.x = -GP142_XMAX + BUT_WIDTH + BUT_HORIZ * 3;
	ptLowerRight.y = GP142_YMAX - NUMBUTTONS * (BUT_HEIGHT) - BUT_TOTALSEP
						- 2 * BUT_VERTSEP2;
	
	GP142_rectangleP(LT_GRAY, ptUpperLeft, ptLowerRight,FILL); 
		
	GP142_rectangleP(BLACK, ptUpperLeft, ptLowerRight, 1); 
}

/* 
 * Draws the buttons 
 */
void DrawButtons(int iSelected, int *ipButtonClick)
{

	GP142_point pt1, pt2;

	char b_labels [NUMBUTTONS][25] = {
		"New Shape",
		"New Message",
		"Next Object",
		"Background Color",
		"Object Color",
		"Select Object",
		"Delete Object"
	};

	int text_offset;
	int label_y;
	
/* The left and right coordinates of all the buttons' endpoints are the same */
	pt1.x = -GP142_XMAX + BUT_HORIZ;	
	pt2.x = -GP142_XMAX + BUT_HORIZ + BUT_WIDTH;
	
	text_offset = pt1.x + 5;

/* When we draw the buttons, they can be either in clicked or un-clicked form. Some
buttons, such as New Shape, New Message, and Select stay clicked after the user pressed
them, and "un-press" if the user clicked on another button or did what he wanted to do.
Other buttons quickly press down and come back up */
	
/* The first two buttons are close together, with separation BUT_VERSEP */

/* Draw the New Shape button */
/* find the top and bottom y coordinates for this button */
	pt1.y = GP142_YMAX - BUT_VERTSEP2;
	pt2.y = pt1.y - BUT_HEIGHT;
	label_y = pt1.y - 3 * BUT_HEIGHT/ 4;
	/* If the user is adding a shape, make the button look pressed */
	if(iSelected == ADDSHAPE)
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[0], TRUE, FALSE);
	else
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[0], FALSE, FALSE);
	
/* Draw the New Message button */
	pt1.y = pt1.y - BUT_HEIGHT - BUT_VERTSEP;
	pt2.y = pt1.y - BUT_HEIGHT;
	label_y = pt1.y - 3 * BUT_HEIGHT/ 4;
	/* If the user is adding a message, make the button look pressed */
	if(iSelected == ADDMESSAGE)
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[1], TRUE, FALSE);
	else
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[1], FALSE, FALSE);

/* Draw the Next Object button, a little farther below the first two buttons*/
	/* Find new top and bottom coordinates */
	pt1.y = pt1.y - BUT_HEIGHT - BUT_VERTSEP2; /* top */
	pt2.y = pt1.y - BUT_HEIGHT;				  /* bottom */
	label_y = pt1.y - 3 * BUT_HEIGHT/ 4;

	if(iSelected > MAXOBJECTS - 1)  /* If no object is selected, make it disabled*/
	{
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[2], FALSE, TRUE);
		*ipButtonClick = B_NONE;	/* Ignore clicks */
	}
	else
	{
		if(*ipButtonClick == B_NEXT) /* Draw the button "clicked" */
		{
			DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[2], TRUE, FALSE);
			/* Flag that this button should not be drawn clicked anymore */
			*ipButtonClick = B_NONE; 
		}
		else
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[2], FALSE, FALSE);
	}
/* Draw two more buttons that are close together, BK Color and Obj Color */
/* Back Color */
	pt1.y = pt1.y - BUT_HEIGHT - BUT_VERTSEP2;	/* top */	
	pt2.y = pt1.y - BUT_HEIGHT;					/* bottom */
	label_y = pt1.y - 3 * BUT_HEIGHT/ 4;
	if(*ipButtonClick == B_BACKCOLOR)
	{
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[3], TRUE, FALSE);
		*ipButtonClick = B_NONE;
	}
	else
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[3], FALSE, FALSE);
/* Obj Color */	
	pt1.y = pt1.y - BUT_HEIGHT - BUT_VERTSEP;
	pt2.y = pt1.y - BUT_HEIGHT;
	label_y = pt1.y - 3 * BUT_HEIGHT/ 4;
	if(iSelected > MAXOBJECTS - 1) /* If no object is selected, make it disabled*/
	{
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[4], FALSE, TRUE);
		*ipButtonClick = B_NONE;
	}
	else
	{
		if(*ipButtonClick == B_OBJECTCOLOR) /* if it's clicked */
		{
			DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[4], TRUE, FALSE);
			*ipButtonClick = B_NONE;
		}
		else
			DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[4], FALSE, FALSE);
	}

/* Draw the last two buttons, Select and Delete, again close together */
	/* Select Button */
	pt1.y = pt1.y - BUT_HEIGHT - BUT_VERTSEP2;	/* top */	
	pt2.y = pt1.y - BUT_HEIGHT;					/* bottom */
	label_y = pt1.y - 3 * BUT_HEIGHT/ 4;
	/* If the user is selecting an object, make the button look pressed */
	if(iSelected == SELECT)
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[5], TRUE, FALSE);
	else
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[5], FALSE, FALSE);

/* Delete button */
	pt1.y = pt1.y - BUT_HEIGHT - BUT_VERTSEP;
	pt2.y = pt1.y - BUT_HEIGHT;
	label_y = pt1.y - 3 * BUT_HEIGHT/ 4;
	if(*ipButtonClick == B_DELETE)
	{
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[6], TRUE, FALSE);
		*ipButtonClick = B_NONE;
	}
	else
		DrawOneButton(pt1, pt2, text_offset, label_y, b_labels[6], FALSE, FALSE);
}

void DrawOneButton(GP142_point pt1, GP142_point pt2, 
				   int text_xoffset, int text_yoffset, 
				   char *pszLabel, int fPressed, int fDisabled)
{
	int font_size = 12;
	int iTextColor;

	if(fDisabled)
		iTextColor = MED_GRAY;
	else
		iTextColor = BLACK;

	DrawButtonSurface(pt1, pt2, fPressed, fDisabled);
	
	if(fPressed)
	{
		text_xoffset++;
		text_yoffset--;
	}
	
	GP142_printfXY(iTextColor, text_xoffset, text_yoffset, font_size, pszLabel);
}

/* Draw a 3d button surface, a rectangle with pt1 and pt2 as its corner points */
/* pt1 is the upper left corner and pt2 is the lower right corner */
void DrawButtonSurface(GP142_point pt1, GP142_point pt2, int fPressed, int fDisabled)
{

	/* Draw the gray rectangle for the button */
	GP142_rectangleP(LT_GRAY, pt1, pt2, FILL);
	GP142_rectangleP(BLACK, pt1, pt2, 1);
	
	if(fPressed)	/* If pressed, don't draw any shading */
	{
		return;
	}

	/* Draw shading on bottom */
	GP142_lineXY(BLACK, pt1.x, pt2.y + 1, pt2.x + 1, pt2.y + 1, 1);
	GP142_lineXY(MED_GRAY, pt1.x + 1, pt2.y + 2, pt2.x, pt2.y + 2, 1); 
	
	/* Draw shading on the right */
	GP142_lineXY(BLACK, pt2.x - 1, pt2.y + 2, pt2.x - 1, pt1.y, 1);
	GP142_lineXY(MED_GRAY, pt2.x - 2, pt2.y + 2, pt2.x - 2, pt1.y, 1);

	/* Draw shading on top */
	GP142_lineXY(WHITE, pt1.x + 1, pt1.y - 1, pt2.x -1, pt1.y - 1, 1);

	/* Draw shading on left */
	GP142_lineXY(WHITE, pt1.x + 1, pt2.y + 3, pt1.x + 1, pt1.y - 1, 1); 

}


/*
 * Render (draw) the page and all its contents.
 */
void DrawCard (int iBackground_color, int iStatus, OBJECT objArray[])
{
	int i, font_size = 14;
	
	/*
	 * Draw the background of the card.
	 */
	GP142_rectangleXY (iBackground_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	
	/* 
	 * Go through the object array, and draw each shape or message
	 */

	for(i = 0; objArray[i].type != OBJECT_NONE && objArray[i].type != OBJECT_END; i++)
	{
		if(objArray[i].type == OBJECT_SHAPE)
			if(iStatus == i)		/* If this shape is selected */
				DrawShape(&objArray[i], iBackground_color, TRUE);
			else
				DrawShape(&objArray[i], iBackground_color, FALSE);
		else
		{
			/* if the message is selected, draw markers indicating that */
			if(iStatus == i)
				DrawMessage(&objArray[i], iBackground_color, TRUE);
			else
				DrawMessage(&objArray[i], iBackground_color, FALSE);
		}
	}


	/*
	 * Write an appropriate status message below the background
	 */
/*	If iStatus is betweeen 0 and MAXOBJECTS - 1, a shape is selected. */

	if(iStatus < MAXOBJECTS - 1)
	{
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Object selected. You can move it, change it, or change its color.");
	}
	if(iStatus == ADDSHAPE)
	{
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Click on the card to add a shape");
	}
	if(iStatus == ADDMESSAGE)
	{
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Click on the card to add a message");
	}

	if(iStatus == SELECT)
	{
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"To select a shape, click on it.  To select a message, click on its first letter");
	}
	if(iStatus== MAXREACHED)
	{
		GP142_printfXY(BLUE, PAGE_LLX, PAGE_LLY-60, font_size,
			"You can't add any more objects to the card.");
		GP142_printfXY(BLUE, PAGE_LLX, PAGE_LLY - 60 - font_size, font_size, 
			"Use ""Delete Object"" to delete an object");
	}


} /*end DrawPage */


/*
 * Draw one shape.
 */
void DrawShape(OBJECT *pobj, int iBackground, int flagSelected) 
{

	switch (pobj->index) {
	case SHAPE_HEART:
		DrawHeart (pobj, iBackground, flagSelected);
		break;
	case SHAPE_STAR:
		DrawStar (pobj, iBackground, flagSelected);
		break;
	case SHAPE_SMILEY:
		DrawSmiley(pobj, iBackground, flagSelected);
		break;
	case SHAPE_SMILEY2:
		DrawSmiley2(pobj, iBackground, flagSelected);
		break;
	case SHAPE_SMILEY3:
		DrawSmiley3(pobj, iBackground, flagSelected);
		break;
	default:
		/* Unknown shape selected */
		break;
	} /*end switch*/
}

void DrawMessage(OBJECT *pobj, int iBackground, int flagSelected)
{

	int iSelectColor;
	GP142_printfXY(pobj->color, pobj->x, pobj->y, pobj->size, FindMessage(pobj->index));
	if(flagSelected)
	{
		/* Draw markers showing the selection area */
		/* Draw the markers in black unless the background is black */
		if(iBackground == BLACK)	
			iSelectColor = MED_GRAY;
		else
			iSelectColor = BLACK;

		GP142_lineXY(iSelectColor, pobj->x, pobj->y, pobj->x, pobj->y + pobj->size / 4, 1);
		GP142_lineXY(iSelectColor, pobj->x, pobj->y, pobj->x + pobj->size / 2, pobj->y, 1);
		
		GP142_lineXY(iSelectColor, pobj->x, pobj->y + pobj->size, pobj->x, pobj->y + 3 * pobj->size / 4, 1);
		GP142_lineXY(iSelectColor, pobj->x, pobj->y + pobj->size, pobj->x + pobj->size / 2, pobj->y + pobj->size, 1);
	
	}
}

char *FindMessage(int iNum)
{
	/* Create an array of strings to store card messages */
	static char arszMessage[MAX_MESSAGES][30] = {
		"LUV U",
		"Be Mine",
		"Be My Valentine",
		"TRUE LOVE!!!",
		"Call Me",
		"Fax Me",
		"E-mail Me",
		"You're Fine, Valentine!"
	};

	return (arszMessage[iNum]);
}



/*
 * Draw a heart on the card. A heart will be made by two overlapping
 * circles and a triangle.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * heart height each time this function is called.
 */
void DrawHeart (OBJECT *pobj, int iBackground, int flagSelect) {

	int HeartWidth = 35;
	int x = pobj->x, y = pobj->y; 
	int h = (HeartWidth/2) + (rand () %4);

	GP142_circleXY (pobj->color, x - h + 5, y, h);
	GP142_circleXY (pobj->color, x + h - 5, y, h);
	GP142_triangleXY (pobj->color, x- h*2 +5, y-5,
						x + h*2 -5, y-5,
						x, y - h*2 -5, FILL);

	if(flagSelect)			/* if selected, draw markers around it */
	{
	
		DrawSelectMarkers(pobj, iBackground);
	}
}

/*
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */
#define STARPOINTS 5
#define STARRADIUS 40
void DrawStar (OBJECT *pobj, int iBackground, int flagSelect) {

	int sp;
	double angle;
	int x1, y1;
	int x = pobj->x, y = pobj->y;
	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (pobj->color, x+x1, y+y1, x-x1, y-y1, 1);

	}
	if(flagSelect)			/* if selected, draw markers around it */
	{
	
		DrawSelectMarkers(pobj, iBackground);
	}
}

void DrawSmiley(OBJECT *pobj, int iBackground, int flagSelect)
{
	
	int iRadius = 30;	/* Radius of the face */
	int iSmileColor;
	
	/* If the face is black, draw the smile and eyes in another color */
	if(pobj->color == BLACK)
		iSmileColor = MED_GRAY;
	else
		iSmileColor = BLACK;
	
	/* Draw a circle for the head */
	GP142_circleXY(pobj->color, pobj->x, pobj->y, iRadius);
	/* Draw the eyes */
	GP142_circleXY(iSmileColor, pobj->x + iRadius / 3, pobj->y + iRadius / 4, iRadius / 15);
	GP142_circleXY(iSmileColor, pobj->x - iRadius / 3, pobj->y + iRadius / 4, iRadius / 15);
	/* Draw a smile! */
	/* The coordinate system for the arc is setup so that when theta == 0 is on the x axis.
	The smile is from 195 degrees to 345 degrees, or from 3.4 to 6.02 radians */
	DrawArc(iSmileColor, 3 * iRadius / 4, 3.4, 6.02, pobj->x, pobj->y, 1);
	/* If selected, draw markers around it */
	if(flagSelect)			/* if selected, draw markers around it */
	{
	
		DrawSelectMarkers(pobj, iBackground);
	}
}

/* A different smiley */
void DrawSmiley2(OBJECT *pobj, int iBackground, int flagSelect)
{

	int iRadius = 30;
	/* Draw a circle (not filled in) */
	DrawArc(pobj->color, iRadius, 0, 2 * PI, pobj->x, pobj->y, 2);
	/* Draw the eyes */
	GP142_circleXY(pobj->color, pobj->x + iRadius / 3, pobj->y + iRadius / 4, iRadius / 15);
	GP142_circleXY(pobj->color, pobj->x - iRadius / 3, pobj->y + iRadius / 4, iRadius / 15);
	/* Draw the smile */
	DrawArc(pobj->color, 3 * iRadius / 5, 3.4, 6.02, pobj->x, pobj->y, 2);
	/* If selected, draw markers around it */
	if(flagSelect)			/* if selected, draw markers around it */
	{
	
		DrawSelectMarkers(pobj, iBackground);
	}
}

/* Yet another smiley */
void DrawSmiley3(OBJECT *pobj, int iBackground, int flagSelect)
{

	int iRadius = 30;	/* Radius of the (non-existent) face */

	/* Draw the eyes */
	GP142_circleXY(pobj->color, pobj->x + iRadius / 3, pobj->y + iRadius / 4, iRadius / 15);
	GP142_circleXY(pobj->color, pobj->x - iRadius / 3, pobj->y + iRadius / 4, iRadius / 15);
	/* Draw a smile! */
	/* The coordinate system for the arc is setup so that when theta == 0 is on the x axis.
	The smile is from 195 degrees to 345 degrees, or from 3.4 to 6.02 radians */
	DrawArc(pobj->color, 3 * iRadius / 4, 3.4, 6.02, pobj->x, pobj->y, 1);
	/* If selected, draw markers around it */
	if(flagSelect)			/* if selected, draw markers around it */
	{
	
		DrawSelectMarkers(pobj, iBackground);
	}
}


/* Assigns a specific shape's properties to an object
These properties are used  mainly to draw selection markers and for
testing for selection */
void AssignShape(OBJECT *pobj)
{
	
	int index;
	
	struct SHAPE {			/* make a structure to hold the shapes */
		int top;
		int bottom;
		int left;
		int right;
	}; 

	/* make an array to hold shapes */
	struct SHAPE shapes[MAX_SHAPES];

	struct SHAPE shpHeart;
	struct SHAPE shpStar;
	struct SHAPE shpSmiley;
	struct SHAPE shpSmiley2;
	struct SHAPE shpSmiley3;

	/* assign a specific shape's inherent properties to each shape */
	shpHeart.top = 17;
	shpHeart.bottom = 35;
	shpHeart.left = 35;
	shpHeart.right = 35;
	
	shpStar.top = 40;
	shpStar.bottom = 40;
	shpStar.left = 40;
	shpStar.right = 40;

	shpSmiley.top = 30;
	shpSmiley.bottom = 30;
	shpSmiley.left = 30;
	shpSmiley.right = 30;

	shpSmiley2 = shpSmiley;
	shpSmiley3 = shpSmiley;

	shapes[0] = shpHeart;
	shapes[1] = shpStar;
	shapes[2] = shpSmiley;
	shapes[3] = shpSmiley2;
	shapes[4] = shpSmiley3;

	
/* assign a shape to an object */

	index = pobj->index;
	pobj->top = shapes[index].top;
	pobj->bottom = shapes[index].bottom;
	pobj->left = shapes[index].left;
	pobj->right = shapes[index].right;
}

/* Draws the selection indicators around a shaped */
void DrawSelectMarkers(OBJECT *pobj, int iBackground)
{

	int iSelectColor;
	int x = pobj->x, y = pobj->y;
	/* Draw the markers in black unless the background is black */
	if(iBackground == BLACK)	
		iSelectColor = MED_GRAY;
	else
		iSelectColor = BLACK;

	/* lower left */
	GP142_lineXY(iSelectColor,
				 x - pobj->left, y - pobj->bottom,
				 x - pobj->left, y - 3 * pobj->bottom / 4,
				 1);

	GP142_lineXY(iSelectColor,
				x - pobj->left, y - pobj->bottom,
				x - 3 * pobj->left / 4, y - pobj->bottom,
				1);		


	/* upper left */
	GP142_lineXY(iSelectColor,
				 x - pobj->left, y + pobj->top,
				 x - pobj->left, y + 3 * pobj->top / 4,
				 1);
	

	GP142_lineXY(iSelectColor,
			 x - pobj->left, y + pobj->top,
			 x - 3 * pobj->left / 4, y + pobj->top,
			 1);

	
	/* lower right */
	GP142_lineXY(iSelectColor,
				 x + pobj->right, y - pobj->bottom,
				 x + pobj->right, y - 3 * pobj->bottom / 4,
				 1);

	GP142_lineXY(iSelectColor,
				 x + pobj->bottom, y - pobj->bottom,
				 x + 3 * pobj->bottom / 4, y - pobj->bottom,
				 1);		
	
	/*upper right */
	GP142_lineXY(iSelectColor,
				 x + pobj->right, y + pobj->top,
				 x + pobj->right, y + 3 * pobj->top / 4,
				 1);
	GP142_lineXY(iSelectColor,
				 x + pobj->right, y + pobj->top,
				 x + 3 * pobj->right / 4, y + pobj->top,
				 1);

}

/*
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int  ClassifyMouseClick(GP142_point ptMouse)
{
  if ((ptMouse.x < -GP142_XMAX + BUT_HORIZ + BUT_WIDTH) &&
	  (ptMouse.x > -GP142_XMAX + BUT_HORIZ) &&
      (ptMouse.y < GP142_YMAX - BUT_VERTSEP2) &&
      (ptMouse.y > (GP142_YMAX - NUMBUTTONS*BUT_HEIGHT) - 
					BUT_TOTALSEP - BUT_VERTSEP2))
	  return CLICK_TOOLBAR;
  else if (ptMouse.x >= PAGE_LLX && ptMouse.x < PAGE_LLX + PAGE_WIDTH
	  && ptMouse.y >= PAGE_LLY && ptMouse.y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;

}


/*
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(GP142_point ptMouse, int *background_color, 
					  int *ipSelected, int *ipButtonClick, OBJECT objArray[])
{

	int mouse_click;
	mouse_click = ClassifyMouseClick(ptMouse);
			
	if (mouse_click == CLICK_TOOLBAR) 
	{
				
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(ptMouse, background_color, ipSelected, ipButtonClick,
					 objArray);
	
	}
	else if(mouse_click == CLICK_CARD) 
	{
		if(*ipSelected == ADDSHAPE)			/* if Add Shape has been clicked */
		{
			/* NewShape returns 0 if MAXOBJECTS objects were placed on card */
			if(!NewShape(ptMouse,  ipSelected, objArray))
				*ipSelected = MAXREACHED;
		}
		else if (*ipSelected == ADDMESSAGE)		/* if Add Message has been clicked */
		{
			/* NewMessage returns 0 if MAXOBJECTS objects were placed on card */
			if(!NewMessage(ptMouse, ipSelected, objArray))
				*ipSelected = MAXREACHED;
		}
		else if(*ipSelected == SELECT)			/* if Select Object has been clicked */
		{
			/* Select an object if mouse was clicked on it */
			Select(ptMouse, ipSelected, objArray);
		}
		else if(*ipSelected < MAXOBJECTS)		/* if one of the objects is selected */
			MoveShape(ptMouse, &objArray[*ipSelected]);
	}
	/* Ignore any other mouse clicks */

}

/* 
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
void HandleButton(GP142_point ptMouse, int *background_color, int *ipSelected,
				  int *ipButtonClick, OBJECT objArray[])
{
	int buttonNum = B_NONE;		/* default nonexistent button value */
	/* If we're outside of this area, we could not have clicked on
	* a button.
	*/
	if (ptMouse.x > -GP142_XMAX + BUT_WIDTH + BUT_HORIZ)
		return ;	/*That's an error situation*/
	
	/* We know the mouse clicked in the column of buttons. Calculate
	*  which one.
	*/
	
	if( ptMouse.y < GP142_YMAX - BUT_VERTSEP2 && 
		ptMouse.y > GP142_YMAX - BUT_VERTSEP2 - BUT_HEIGHT)
	{
		buttonNum = B_NEWSHAPE;		/* New Shape */
	}
	if( ptMouse.y < GP142_YMAX - BUT_VERTSEP2 - BUT_HEIGHT - BUT_VERTSEP &&
		ptMouse.y > GP142_YMAX - BUT_VERTSEP2 - BUT_HEIGHT * 2 - BUT_VERTSEP)
	{
		buttonNum = B_NEWMESSAGE;		/* New Message */
	}
	if( ptMouse.y < GP142_YMAX - 2 * BUT_VERTSEP2 - 2 * BUT_HEIGHT - BUT_VERTSEP &&
		ptMouse.y > GP142_YMAX - 2 * BUT_VERTSEP2 - 3 * BUT_HEIGHT - BUT_VERTSEP)
	{
		buttonNum = B_NEXT;		/* Next Object */
	}
	if( ptMouse.y < GP142_YMAX - 3 * BUT_VERTSEP2 - 3 * BUT_HEIGHT - BUT_VERTSEP &&
		ptMouse.y > GP142_YMAX - 3 * BUT_VERTSEP2 - 4 * BUT_HEIGHT - BUT_VERTSEP)
	{
		buttonNum = B_BACKCOLOR;		/* Background Color */
	}
	if( ptMouse.y < GP142_YMAX - 3 * BUT_VERTSEP2 - 4 * BUT_HEIGHT - 2 * BUT_VERTSEP &&
		ptMouse.y > GP142_YMAX - 3 * BUT_VERTSEP2 - 5 * BUT_HEIGHT - 2 * BUT_VERTSEP)
	{
		buttonNum = B_OBJECTCOLOR;		/* Object Color */
	}
	if( ptMouse.y < GP142_YMAX - 4 * BUT_VERTSEP2 - 5 * BUT_HEIGHT - 2 * BUT_VERTSEP &&
		ptMouse.y > GP142_YMAX - 4 * BUT_VERTSEP2 - 6 * BUT_HEIGHT - 2 * BUT_VERTSEP)
	{
		buttonNum = B_SELECT;		/* Select Object */
	}
	if( ptMouse.y < GP142_YMAX - 4 * BUT_VERTSEP2 - 6 * BUT_HEIGHT - 3 * BUT_VERTSEP &&
		ptMouse.y > GP142_YMAX - 4 * BUT_VERTSEP2 - 7 * BUT_HEIGHT - 2 * BUT_VERTSEP)
	{
		buttonNum = B_DELETE;		/* Delete Object */
	}

	switch(buttonNum) {
	case 0:
		/* Add Shape */
		*ipSelected = ADDSHAPE; /* flag indicating a shape is to be added*/
		break;
	case 1:
		/* Add Message */
		*ipSelected = ADDMESSAGE;
		break;
	case 2:
		/* Change the object */
		/* Indicate that this button has been clicked, used in DrawButtons() */
		*ipButtonClick = B_NEXT;

		if(objArray[*ipSelected].type == OBJECT_SHAPE)
		{
			objArray[*ipSelected].index = (objArray[*ipSelected].index + 1) % MAX_SHAPES;
			/*Assign new information about the new shape's dimensions */
			AssignShape(&objArray[*ipSelected]);  
		}
		else if(objArray[*ipSelected].type == OBJECT_MESSAGE)
		{
			objArray[*ipSelected].index = (objArray[*ipSelected].index + 1) % MAX_MESSAGES;
		} 
		break;
	case 3:
		/* Change the background color */
		*ipButtonClick = B_BACKCOLOR;
		*background_color = (*background_color + 1) % MAX_COLORS;
		break;
	case 4:
		/* Change the object's color */
		*ipButtonClick = B_OBJECTCOLOR;
		if(*ipSelected < MAXOBJECTS)		/* if there's an object selected */
		{
			/* find selected object */
			objArray[*ipSelected].color = (objArray[*ipSelected].color + 1) % MAX_COLORS;
		}
		break;
	case 5:
		/* Select Object */
		*ipSelected = SELECT;
		break;
	case 6:
		/* Delete Object */
		*ipButtonClick = B_DELETE;
		/* If an object is actually selected and if it is not OBJECT_NONE for some reason */
		if(*ipSelected < MAXOBJECTS - 1 && objArray[*ipSelected].type != OBJECT_NONE)
		{
			Delete(objArray, ipSelected);
		}
		break;
	default:	/* Mouse was clicked somewhere in the space in between buttons */
		break;
	}
}



/* If there's room for another shape, add it to the card. */
/* If there's no room, return 0, otherwise, return 1 */
int NewShape(GP142_point ptMouse, int *ipSelected, OBJECT objArray[])

{
	int i;
	/* This loop looks for an empty slot in the array. */
	for(i = 0; i < MAXOBJECTS; i++)
	{
		if(objArray[i].type == OBJECT_NONE)
			break;
	}
	if(i != MAXOBJECTS)	/*If a space was found */
	{
		*ipSelected = i;
		objArray[i].type = OBJECT_SHAPE;
		objArray[i].index = SHAPE_HEART;
		objArray[i].color = RED;
		objArray[i].x = ptMouse.x;
		objArray[i].y = ptMouse.y;
		AssignShape(&objArray[i]); /* Fills in some other of shape's properties */

		return 1;
	}
	/* Array is full */
	return 0;
}
/* Add a new message, if we have more than MAXOBJECTS objects, return 0, otherwise return 1 */
int NewMessage(GP142_point ptMouse, int *ipSelected, OBJECT objArray[])
{
	int i;
	
	for(i = 0; i < MAXOBJECTS; i++)
	{
		if(objArray[i].type == OBJECT_NONE)
			break;
	}
	if(i != MAXOBJECTS)
	{
		*ipSelected = i;
		objArray[i].type = OBJECT_MESSAGE;
		objArray[i].index = 0;
		objArray[i].color = BLUE;
		objArray[i].x = ptMouse.x;
		objArray[i].y = ptMouse.y;
		objArray[i].size = FONT_SIZE;
		
		return 1;
	}
	return 0;
}


/* Move a shape somewhere else on card */
void MoveShape(GP142_point ptMouse, OBJECT *pobjObject)
{
	pobjObject->x = ptMouse.x;
	pobjObject->y = ptMouse.y;
}

/* Check whether the mouse was clicked on an object, and select that object */
void Select(GP142_point ptMouse, int *ipSelected, OBJECT objArray[])
{
	int i;

	/* The for loop is arranged in this way so that when two shapes overlap,
	it will select the one that is on top, since the first shape is assigned
	the lowest index */
	for(i = MAXOBJECTS - 2; i >= 0; i--)
	{
		if(objArray[i].type == OBJECT_MESSAGE)
		/* Selection of strings */
		{
			if((ptMouse.x > objArray[i].x && ptMouse.x < objArray[i].x + objArray[i].size)
				&& (ptMouse.y > objArray[i].y && ptMouse.y < objArray[i].y + objArray[i].size))
			{
				*ipSelected = i;
				break;
			}
		}
		if(objArray[i].type == OBJECT_SHAPE)
		/* Test if mouse coordinates are inside the shape */
		{
			if((ptMouse.x > objArray[i].x - objArray[i].left 
				&& ptMouse.x < objArray[i].x + objArray[i].right)
				&& (ptMouse.y > objArray[i].y - objArray[i].bottom 
				&& ptMouse.y < objArray[i].y + objArray[i].top))
			{
				*ipSelected = i;
				break;
			}
		}
	}
}

/* Deltes an object from an object array, without creating "holes" in the array */
void Delete(OBJECT objArray[], int *ipSelected)
{
	
	int i;

	
	/* The last element in the array is always OBJECT_END.  To delete an object if the
	object is the second to the last element in the array, or it is the last object recorded 
	in the array, simply assign its type to OBJECT_NONE */
	if(objArray[*ipSelected + 1].type == OBJECT_END || objArray[*ipSelected + 1].type == OBJECT_NONE)
	{
		objArray[*ipSelected].type = OBJECT_NONE;
		if(*ipSelected != 0)
			(*ipSelected)--;		/* make the last object placed selected */
		else
			*ipSelected = ADDSHAPE;	/* all objects are erased, add a new shape when the card is clicked */
	}
	else
	{
		/* To delete an object if it is in between other objects, shift all objects to the right
		of the selected object one element to the left */
		for(i = *ipSelected + 1; ; i++)
		{
			objArray[i - 1] = objArray[i];
			if(objArray[i].type == OBJECT_NONE)	/* If we just copied OBJECT_NONE, we're done */
				break;
			/* If we reached the end of the array, assign  OBJECT_NONE to second to the last
			element (the one we just copied */
			if(objArray[i+1].type == OBJECT_END)
			{	
				objArray[i].type = OBJECT_NONE;
				break;
			}
		}
	}
}

void InitArray(OBJECT objArray[])
{
	int i;
	
	for(i = 0; i < MAXOBJECTS - 1; i++)
	{
		objArray[i].type = OBJECT_NONE;
	}
	objArray[MAXOBJECTS - 1].type = OBJECT_END;
}